{
    "$graph": [
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#main/barcodes"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 20
                    },
                    "id": "#main/block_size"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#main/features"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 9
                    },
                    "id": "#main/filterDataR"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#main/loadDataR"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 19
                    },
                    "id": "#main/margin"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#main/matrix"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 5
                    },
                    "id": "#main/minCells"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 6
                    },
                    "id": "#main/minFeatures"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 13
                    },
                    "id": "#main/nCountRNAmax"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 12
                    },
                    "id": "#main/nCountRNAmin"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 11
                    },
                    "id": "#main/nFeatureRNAmax"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 10
                    },
                    "id": "#main/nFeatureRNAmin"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 17
                    },
                    "id": "#main/normalization_method"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 16
                    },
                    "id": "#main/normalizeDataR"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 8
                    },
                    "id": "#main/pattern"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 15
                    },
                    "id": "#main/percentMTmax"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 14
                    },
                    "id": "#main/percentMTmin"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 7
                    },
                    "id": "#main/projectName"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 18
                    },
                    "id": "#main/scale_factor"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 21
                    },
                    "id": "#main/verbose"
                }
            ],
            "steps": [
                {
                    "run": "#2_filter.cwl",
                    "in": [
                        {
                            "source": "#main/loadData/loaded_data",
                            "id": "#main/filterData/dataFile"
                        },
                        {
                            "source": "#main/nCountRNAmax",
                            "id": "#main/filterData/nCountRNAmax"
                        },
                        {
                            "source": "#main/nCountRNAmin",
                            "id": "#main/filterData/nCountRNAmin"
                        },
                        {
                            "source": "#main/nFeatureRNAmax",
                            "id": "#main/filterData/nFeatureRNAmax"
                        },
                        {
                            "source": "#main/nFeatureRNAmin",
                            "id": "#main/filterData/nFeatureRNAmin"
                        },
                        {
                            "source": "#main/percentMTmax",
                            "id": "#main/filterData/percentMTmax"
                        },
                        {
                            "source": "#main/percentMTmin",
                            "id": "#main/filterData/percentMTmin"
                        },
                        {
                            "source": "#main/filterDataR",
                            "id": "#main/filterData/script"
                        }
                    ],
                    "out": [
                        "#main/filterData/filtered_data",
                        "#main/filterData/plots"
                    ],
                    "id": "#main/filterData"
                },
                {
                    "run": "#1_loadData.cwl",
                    "in": [
                        {
                            "source": "#main/barcodes",
                            "id": "#main/loadData/barcodes"
                        },
                        {
                            "source": "#main/features",
                            "id": "#main/loadData/features"
                        },
                        {
                            "source": "#main/matrix",
                            "id": "#main/loadData/matrix"
                        },
                        {
                            "source": "#main/minCells",
                            "id": "#main/loadData/minCells"
                        },
                        {
                            "source": "#main/minFeatures",
                            "id": "#main/loadData/minFeatures"
                        },
                        {
                            "source": "#main/pattern",
                            "id": "#main/loadData/pattern"
                        },
                        {
                            "source": "#main/projectName",
                            "id": "#main/loadData/projectName"
                        },
                        {
                            "source": "#main/loadDataR",
                            "id": "#main/loadData/script"
                        }
                    ],
                    "out": [
                        "#main/loadData/loaded_data",
                        "#main/loadData/plot0"
                    ],
                    "id": "#main/loadData"
                },
                {
                    "run": "#3_normalization.cwl",
                    "in": [
                        {
                            "source": "#main/block_size",
                            "id": "#main/normalizeData/block_size"
                        },
                        {
                            "source": "#main/filterData/filtered_data",
                            "id": "#main/normalizeData/dataFile"
                        },
                        {
                            "source": "#main/margin",
                            "id": "#main/normalizeData/margin"
                        },
                        {
                            "source": "#main/normalization_method",
                            "id": "#main/normalizeData/normalization_method"
                        },
                        {
                            "source": "#main/scale_factor",
                            "id": "#main/normalizeData/scale_factor"
                        },
                        {
                            "source": "#main/normalizeDataR",
                            "id": "#main/normalizeData/script"
                        },
                        {
                            "source": "#main/verbose",
                            "id": "#main/normalizeData/verbose"
                        }
                    ],
                    "out": [
                        "#main/normalizeData/normalized_data"
                    ],
                    "id": "#main/normalizeData"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/loadData/plot0",
                    "id": "#main/step11utput"
                },
                {
                    "type": "File",
                    "outputSource": "#main/loadData/loaded_data",
                    "id": "#main/step1Output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/filterData/plots",
                    "id": "#main/step22Output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/filterData/filtered_data",
                    "id": "#main/step2Output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/normalizeData/normalized_data",
                    "id": "#main/step3Output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "Rscript",
            "hints": [
                {
                    "dockerPull": "fleming/sc-rna-seq:latest",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#1_loadData.cwl/barcodes"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#1_loadData.cwl/features"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#1_loadData.cwl/matrix"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 5
                    },
                    "id": "#1_loadData.cwl/minCells"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 6
                    },
                    "id": "#1_loadData.cwl/minFeatures"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 8
                    },
                    "id": "#1_loadData.cwl/pattern"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 7
                    },
                    "id": "#1_loadData.cwl/projectName"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#1_loadData.cwl/script"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "QC.rds"
                    },
                    "id": "#1_loadData.cwl/loaded_data"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "plot0.jpeg"
                    },
                    "id": "#1_loadData.cwl/plot0"
                }
            ],
            "id": "#1_loadData.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "Rscript",
            "hints": [
                {
                    "dockerPull": "fleming/sc-rna-seq:latest",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#2_filter.cwl/dataFile"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 6
                    },
                    "id": "#2_filter.cwl/nCountRNAmax"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 5
                    },
                    "id": "#2_filter.cwl/nCountRNAmin"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#2_filter.cwl/nFeatureRNAmax"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#2_filter.cwl/nFeatureRNAmin"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 8
                    },
                    "id": "#2_filter.cwl/percentMTmax"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 7
                    },
                    "id": "#2_filter.cwl/percentMTmin"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#2_filter.cwl/script"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "Filter.rds"
                    },
                    "id": "#2_filter.cwl/filtered_data"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "plot1.jpeg"
                    },
                    "id": "#2_filter.cwl/plots"
                }
            ],
            "id": "#2_filter.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "Rscript",
            "hints": [
                {
                    "dockerPull": "fleming/sc-rna-seq:latest",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 6
                    },
                    "id": "#3_normalization.cwl/block_size"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#3_normalization.cwl/dataFile"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 5
                    },
                    "id": "#3_normalization.cwl/margin"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#3_normalization.cwl/normalization_method"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#3_normalization.cwl/scale_factor"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#3_normalization.cwl/script"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 7
                    },
                    "id": "#3_normalization.cwl/verbose"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "Normalization.rds"
                    },
                    "id": "#3_normalization.cwl/normalized_data"
                }
            ],
            "id": "#3_normalization.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
